<?php
// $Id: 20_CGI.php.create.Vsite
// Copyright (c) 2014 Michael Stauber, SOLARSPEED.NET
// Copyright (c) 2014 Team BlueOnyx, BLUEONYX.IT
//
// ui extension to set settings for cgi Vsite creation

if(defined("CGI_EXTENSION_CREATE_VSITE"))
{
    return 1;
}
define("CGI_EXTENSION_CREATE_VSITE", 1);

include_once("UIExtension.php");

class CGIExtension extends UIExtension
{
    function display(&$helper, &$container, &$cce_info)
    {
        $CI =& get_instance();
        $factory =& $helper->getHtmlComponentFactory("base-apache");
        $cce =& $helper->getCceClient();
    
        $defaults = $cce->get($cce_info["CCE_SERVICES_OID"], 'CGI');
        
        // only add page if not already there
        if ($cce_info['CAN_ADD_PAGE'])
        {
            $pageId = 'webScripting';
            if (!in_array('webScripting', $container->getPageIds()))
            {
                $container->addPage("webScripting", 
                    $factory->getLabel("webScripting"));
            }
        }
        else
        {
            $pageId = $cce_info['PAGED_BLOCK_DEFAULT_PAGE'];
        }

        //
        //-- Reseller: Can the reseller that owns this Vsite modify this?
        //
        $VsiteOwnerObj = $CI->BX_SESSION['loginUser'];
        $access = "rw";
        if ($VsiteOwnerObj['name'] != "admin") {
            $resellerCaps = $cce->scalar_to_array($VsiteOwnerObj['capabilities']);
            if (!in_array('resellerCGI', $resellerCaps)) {
                $defaults["enabled"] = '0';
                $access = 'r';
            }
        }

        //--

	    $container->addFormField(
			$factory->getBoolean('cgi', $defaults['enabled'], $access),
		    $factory->getLabel('cgi'),
			$pageId
		    );
    }

    function handle(&$helper, &$errors, &$cce_info, &$attributes)
    {
        $this->attributes = $attributes;

        $cce =& $helper->getCceClient();

        $cce->set($cce_info["CCE_OID"], 'CGI', array('enabled' => $this->attributes['cgi']));

        $errors = array_merge($errors, $cce->errors());
    }
}


